//This  program for testing "IICmaster DMA emulator" was verified on PIC 16F1825
#include<xc.h>
#include "IICmaster.h"

volatile static bit W;          //bit flags I2C writing, not necessary here
volatile static char EW[16],ER[16],i;//RAM array for EEPROM writing and reading
/*
volatile static union
{
 unsigned int W;
 unsigned char B[2];
}u;
*/

#define LED LATA4

#ifdef transfered
inline void IICtransfered(void) //can be called at the end of IICinterrupt() service,
                                //when IIC transfer of packet stop. 
{

}
#endif


void interrupt InterruptService(void)  //obsluha preruseni
{   
  //can also contains services of interrupts from other PIC models 
      IICinterrupt();       //interrupt by I2C transfer
}


void main(void)
{
 	//osc. internal HF, 16MHz
  OSCCONbits.IRCF=0b1111;
  OSCCONbits.SCS=0b11;
  OSCTUNE=0b111;
  //ports
  ANSELC=0b00000000; 	//analog inputs off/analogove vstupy vyp
  PORTC=  0b11110111;
  ANSELA=0b00000000; 	
  TRISA= 0b11101111;	//enable inputs/povoli vstupy krome RES*/
  TRISC= 0b11100111;	//povoli vystupy TX,RTS
                        
  T1CON= 0b00100001;	//LED blik timing/T1 casovani lED
  /*
            //UART config
   SPBRG=12;		//19200baud
   SYNC=0;
   SSPEN=1;		//enable serial port
   TXEN=1;
   CREN=1;		//enable receiving/povoli prijem
   RCIE=1;
*/
 GIE=1;PEIE=1;          //enable interrupts //povoli preruseni

        //configure I2C
 IICconfig(199);
                                //write 16 bytes to EEPROM
 IIC.devAdr=  0b1010000;        //serial EEPROM slave adr
 IIC.wordAdr= 0b00000000;
 IIC.LongWordAdr=1;         //2 bytes word adr flag
 IIC.wordAdr2=0b00000000;
 IIC.bytes =16;             //number of bytes to write
 for(i=0;i<16;i++)
     EW[i]=0x30+i;          // preset of transfered RAM
 W=1;                       //auxiliary  bit for writing is not necessary here
                            //beacuse there are only reading in main loop
 if(!IIC.Write && !IIC.Read && W)
     {
       IIC.pointerDMA=&EW[0];   //
       IIC.Write=1;
       SEN=1;                   //set start of I2C transfer
     }
 TMR1IF=0;
 W=0;
 i=0;
 while(1)
 {
    if(TMR1IF)
    {TMR1IF=0;
     LED=!LED;
        //read   byte by byte from slave chip into RAM
     if(!IIC.Read && !IIC.Write && !W)
     {
       IIC.bytes =1;
       IIC.pointerDMA=&ER[i];
       IIC.Read=1;
       IIC.wordAdr2=i;
       SEN=1;
       i++;
       i &= 0x0f; //repeat reading of 16 written bytes
     }
    }
  }
}